<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">
      <el-form-item label="标题" prop="title">
        <el-input v-model="queryParams.title" placeholder="请输入标题" clearable size="small"
          @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item label="语言" prop="classification">
        <el-select v-model="queryParams.language" placeholder="请选择语言" clearable size="small">
          <el-option label="中文" value="中文" />
          <el-option label="English" value="English" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" icon="el-icon-plus" size="mini" @click="handleAdd"
          v-permission="['cloud:aboutUsInfo:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-permission="['cloud:aboutUsInfo:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-permission="['cloud:aboutUsInfo:remove']">删除</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-permission="['cloud:aboutUsInfo:export']"
        >导出</el-button>
      </el-col> -->
    </el-row>

    <el-table v-loading="loading" :data="aboutUsInfoList" @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="" align="center" prop="id" /> -->
      <el-table-column label="公司标题" align="center" prop="title" />
      <el-table-column label="公司简介" align="center" prop="details">
        <template slot-scope="scope">
          <el-popover trigger="hover" placement="top">
            <p v-html="scope.row.details"></p>
            <div slot="reference" class="name-wrapper">
              <el-tag size="medium">{{ scope.row.details }}</el-tag>
            </div>
          </el-popover>
        </template>
    </el-table-column>
      <!-- <el-table-column label="副标题" align="center" prop="deputyTitle" /> -->
      <el-table-column label="公司封面" align="center" width="180">
        <template slot-scope="scope">
          <img :src="scope.row.coverImage" alt="" style="width:100px;height:50px">
        </template>
      </el-table-column>
      <!-- <el-table-column label="时间轴" align="center" prop="coverImage" /> -->
      <!-- <el-table-column label="视频地址" align="center" prop="videoUrl" /> -->
      <!-- <el-table-column label="分类" align="center" prop="classify" /> -->
      <el-table-column label="文章标题" align="center" prop="deputyTitle" />
      <el-table-column label="文章内容" align="center">
        <template slot-scope="scope">
          <el-popover trigger="hover" placement="top">
            <p v-html="scope.row.content"></p>
            <div slot="reference" class="name-wrapper">
              <el-tag size="medium">{{scope.row.content}}</el-tag>
            </div>
          </el-popover>
        </template>
    </el-table-column>
      <el-table-column label="语言" align="center" prop="language" />
      <el-table-column label="创建时间" align="center" prop="gmtCreate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.gmtCreate) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="" align="center" prop="gmtUpdate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.gmtUpdate) }}</span>
        </template>
      </el-table-column>

      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-permission="['cloud:aboutUsInfo:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-permission="['cloud:aboutUsInfo:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改记录关于我们信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1000px" @opened="openDialog">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="公司标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入公司标题" />
        </el-form-item>
        <el-form-item label="公司封面" prop="coverImage">
          <el-upload ref="mYupload" class="avatar-uploader" :headers="headers" :action="uploadPath"
            :show-file-list="false" :on-success="uploadSuccessHandle" :before-upload="onBeforeUpload">
            <img v-if="form.coverImage" :src="form.coverImage" class="avatar">
            <i v-else class="el-icon-plus avatar-uploader-icon"></i>
          </el-upload>
        </el-form-item>
        <el-form-item label="公司简介" prop="details">
          <!-- <el-input v-model="form.details" type="textarea" placeholder="公司简介" /> -->
          <textarea id="ck-editor" name="editor" rows="10" cols="80"></textarea>
        </el-form-item>
        <!-- <el-form-item label="时间轴">
        </el-form-item>
        <el-form-item style="display: flex;">
          <div style="display: flex;" v-for="(item,index) in timeLine">
            <div style="display: flex;">
              <span style="width: 100px;">时间</span>
              <el-input v-model="item.time" placeholder="时间" />
            </div>
            <div style="display: flex;margin-left:20px">
              <span style="width: 40px;">内容</span>
              <el-input v-model="item.text" placeholder="内容" />
            </div>
            <div style="margin-left: 40px;">
              <span @click="addTimeLine(item,index)">增加</span>
              <span style="margin-left: 20px;"  @click="jsTimeLine(item,index)">减少</span>
            </div>
          </div>
        </el-form-item> -->
        <el-form-item label="文章标题" prop="deputyTitle">
          <el-input v-model="form.deputyTitle" placeholder="请输入文章标题" />
        </el-form-item>
        <el-form-item label="文章内容" prop="content">
          <textarea id="ck-editor1" name="editor" rows="10" cols="80"></textarea>
          <!-- <el-input v-model="form.content" placeholder="请输入文章内容" type="textarea" /> -->
        </el-form-item>
        <el-radio-group v-model="form.language">
          <el-radio-button label="中文"></el-radio-button>
          <el-radio-button label="English"></el-radio-button>
        </el-radio-group>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAboutUsInfo, getAboutUsInfo, delAboutUsInfo, addAboutUsInfo, updateAboutUsInfo, exportAboutUsInfo } from "@/api/cloud/aboutUsInfo";
import { uploadPath } from '@/api/storage'
import { getToken } from '@/utils/auth'
export default {
  data() {
    return {
      editor: null,
      editor1: null,
      editorData: '<p>Content of the editor.</p>',
      editorConfig: {
        // The configuration of the editor.
      },
      timeLine: [{
        time: '',
        text: ''
      }],
      uploadPath,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 记录关于我们信息表格数据
      aboutUsInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        title: undefined,
        deputyTitle: undefined,
        coverImage: undefined,
        videoUrl: undefined,
        classify: undefined,
        content: undefined,
        details: undefined,
        language: undefined,
        status: undefined,
        gmtCreate: undefined,
        gmtUpdate: undefined,
        deleteFlag: undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  computed: {
    headers() {
      return {
        accessToken: getToken()
      }
    }
  },
  created() {
    this.getList();
  },
  mounted() {
   
  },
  methods: {
    openDialog(){
      window.CKEDITOR.replace('ck-editor', { height: '400px', width: '100%', toolbar: 'toolbar_Full' });
    this.editor = window.CKEDITOR.instances['ck-editor']
    this.editor.on('fileUploadRequest', evt => {
      const requestData = evt.data.requestData
      const upload = requestData.upload
      delete requestData.upload
      requestData.file = upload
    })

    this.editor.on('fileUploadResponse', evt => {
      evt.stop();
      const data = evt.data
      const fileLoader = data.fileLoader
      const res = JSON.parse(fileLoader.xhr.responseText)
      console.log(res)
      if (res.errno !== 200) {
        data.message = '上传失败'
        evt.cancel();
        return
      }
      data.fileName = fileLoader.fileName
      data.url = res.url
      data.message = '上传成功'
    })

    window.CKEDITOR.replace('ck-editor1', { height: '400px', width: '100%', toolbar: 'toolbar_Full' });
    this.editor1 = window.CKEDITOR.instances['ck-editor1']
    this.editor1.on('fileUploadRequest', evt => {
      const requestData = evt.data.requestData
      const upload = requestData.upload
      delete requestData.upload
      requestData.file = upload
    })

    this.editor1.on('fileUploadResponse', evt => {
      evt.stop();
      const data = evt.data
      const fileLoader = data.fileLoader
      const res = JSON.parse(fileLoader.xhr.responseText)
      console.log(res)
      if (res.errno !== 200) {
        data.message = '上传失败'
        evt.cancel();
        return
      }
      data.fileName = fileLoader.fileName
      data.url = res.url
      data.message = '上传成功'
    })
    },
    InsertHTML(html) {
      // Get the editor instance that you want to interact with.
      // var value = document.getElementById('ck-editor').value;
      console.log(this.editor.getData())
      // Check the active editing mode.
      if (this.editor.mode == 'wysiwyg') {
        // Insert HTML code.
        // https://ckeditor.com/docs/ckeditor4/latest/api/CKEDITOR_editor.html#method-insertHtml

        this.editor.setData(html);
      } else
        alert('You must be in WYSIWYG mode!');
    },
    getContent() {
      console.log(this.editor.getData())
    },
    InsertHTML1(html) {
      // Get the editor instance that you want to interact with.
      // var value = document.getElementById('ck-editor').value;
      console.log(this.editor.getData())
      // Check the active editing mode.
      if (this.editor1.mode == 'wysiwyg') {
        // Insert HTML code.
        // https://ckeditor.com/docs/ckeditor4/latest/api/CKEDITOR_editor.html#method-insertHtml

        this.editor1.setData(html);
      } else
        alert('You must be in WYSIWYG mode!');
    },
    getContent1() {
      console.log(this.editor1.getData())
    },
    addTimeLine(val, index) {
      this.timeLine.push({
        time: '',
        text: ''
      })
    },
    jsTimeLine(val, index) {
      debugger
      this.timeLine.splice(index, 1)
    },
    // 上传图片了处理图片
    uploadSuccessHandle(e, file) {
      const that = this
      this.form.coverImage = e.url
      this.$forceUpdate()
    },
    onBeforeUpload(file) {
      const isIMAGE = file.type === 'image/jpeg' || 'image/gif' || 'image/png' || 'image/jpg'
      const isLt1M = file.size / 1024 / 1024 < 1

      if (!isIMAGE) {
        this.$message.error('上传文件只能是图片格式!')
      }
      if (!isLt1M) {
        this.$message.error('上传文件大小不能超过 1MB!')
      }
      return isIMAGE && isLt1M
    },
    // 上传图片了处理图片
    uploadSuccessHandle1(e, file) {
      const that = this
      this.form.videoUrl = e.url
      this.$forceUpdate()
    },

    /** 查询记录关于我们信息列表 */
    getList() {
      this.loading = true;
      listAboutUsInfo(this.queryParams).then(response => {
        this.aboutUsInfoList = response.data.data.items
        this.total = response.data.data.count
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        title: undefined,
        deputyTitle: undefined,
        coverImage: undefined,
        videoUrl: undefined,
        classify: undefined,
        content: undefined,
        details: undefined,
        language: undefined,
        status: "0",
        gmtCreate: undefined,
        gmtUpdate: undefined,
        deleteFlag: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length != 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加记录关于我们信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids.join(',')
      getAboutUsInfo(id).then(response => {
        let that = this
        this.form = response.data.data
        setTimeout(()=>{that.InsertHTML(that.form.details)},1000) 
        setTimeout(()=>{that.InsertHTML1(that.form.content)},1000) 
        this.open = true;
        this.title = "修改记录关于我们信息";
      });
    },
    /** 提交按钮 */
    submitForm: function () {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.details = this.editor.getData()
          this.form.content = this.editor1.getData()
          if (this.form.id != undefined) {
            updateAboutUsInfo(this.form).then(response => {
              if (response.data) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          } else {
            addAboutUsInfo(this.form).then(response => {
              if (response.data) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids.join(',')
      this.$confirm('是否确认删除记录关于我们信息编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delAboutUsInfo(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(function () { });
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有记录关于我们信息数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportAboutUsInfo(queryParams);
      }).then(response => {
        this.download(response.data.data);
      }).catch(function () { });
    }
  }
};
</script>
<style lang="scss" scoped>
.avatar-uploader {
  /deep/.el-upload {
    border: 1px dashed #ccc;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
}

.avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}

.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}

.avatar {
  width: 178px;
  height: 178px;
  display: block;
}
.ck-editor__editable {
  min-height: 400px;
}
</style>